/*
*   Variables are named with following convention:
*   Result_Property_Name
*
*   Where "Result" refers to the outcome of a logical operation, math operation, comparison, value, etc.
*   Where "Property" refers to the property that the varaible will be bound to, such as, visibility, disable
*       value, isChecked, etc.
*   Where "Name" is the intuitive name for the result, such as, 
*       VDS Current limit threshold = VdsOcpThreshold
*       
*/

function regPropsVariablesBindings() 
{
    //VARIABLE DECLARATIONS
    //////////////////////////////////////////////////////////////////////
    //Actual non register values
    gc.databind.registry.getBinding('props.value_value_ID_REF');
    
    // Calculated values
    // gc.databind.registry.getBinding('props.calculation_value_BusCurrentLimit');
    // gc.databind.registry.getBinding('props.calculation_value_IPDCurrentThreshold');
    // gc.databind.registry.getBinding('props.calculation_value_MPETIPDCurrentThreshold');
    // gc.databind.registry.getBinding('props.calculation_value_MPETOpenLoopCurrentReference');
    // gc.databind.registry.getBinding('props.calculation_value_MPETOpenLoopSpeedReference');
    // gc.databind.registry.getBinding('props.calculation_value_MinimumSpeedThresholdtoResync');
    // gc.databind.registry.getBinding('props.calculation_value_BrakeCurrentThreshold');
    // gc.databind.registry.getBinding('props.calculation_value_AlignOrSlowFirstCycleCurrentLimit');
    // gc.databind.registry.getBinding('props.calculation_value_FrequencyFirstCycle');
    // gc.databind.registry.getBinding('props.calculation_value_OpenLoopCurrentLimitSpeedReversal');
    gc.databind.registry.getBinding('props.calculation_value_ReverseDriveOpenLoopDecelerationA1');
    gc.databind.registry.getBinding('props.calculation_value_ReverseDriveOpenLoopDecelerationA2');
    gc.databind.registry.getBinding('props.calculation_value_ReverseDeclerationSpeedThreshold');
    // gc.databind.registry.getBinding('props.calculation_value_PlugBusCurrentLimit');
    // gc.databind.registry.getBinding('props.calculation_value_OpenLoopCurrentLimit');
    // gc.databind.registry.getBinding('props.calculation_value_OpenToClosedLoopCurrentLimit');
    // gc.databind.registry.getBinding('props.calculation_value_IqThresholdDuringRampDown');
    // gc.databind.registry.getBinding('props.calculation_value_TorquePILoopCurrentLimit');
    gc.databind.registry.getBinding('props.calculation_value_ActiveSpinDownSpeedThreshold');
    gc.databind.registry.getBinding('props.calculation_value_MotorStopSpeedThreshold');
    // gc.databind.registry.getBinding('props.calculation_value_HWLockDetectionCurrentLimit');
    // gc.databind.registry.getBinding('props.calculation_value_LockDetectionCurrentThreshold');
    // gc.databind.registry.getBinding('props.calculation_value_AbnormalSpeedLockThreshold');
    // gc.databind.registry.getBinding('props.calculation_value_AbnormalBEMFLockThreshold');
    // gc.databind.registry.getBinding('props.calculation_value_NoMotorLockThreshold');
    
    gc.databind.registry.getBinding('props.value_MaxSpeed')
    gc.databind.registry.getBinding('props.calculation_value_SpeedCommand');
    gc.databind.registry.getBinding('props.calculation_value_VoltageMagnitude');
    gc.databind.registry.getBinding('props.calculation_value_MotorElectricalSpeed');
    gc.databind.registry.getBinding('props.calculation_value_VMVoltage');
    gc.databind.registry.getBinding('props.calculation_value_VoltageGain');
    gc.databind.registry.getBinding('props.calculation_value_CSAGain');
    gc.databind.registry.getBinding('props.calculation_value_IdRefClosedLoop');
    gc.databind.registry.getBinding('props.calculation_value_IqRefClosedLoop');
    gc.databind.registry.getBinding('props.calculation_value_EstimatedId');
    gc.databind.registry.getBinding('props.calculation_value_EstimatedIq');
    gc.databind.registry.getBinding('props.calculation_value_Vd');
    gc.databind.registry.getBinding('props.calculation_value_Vq');
    gc.databind.registry.getBinding('props.calculation_value_BusCurrent');
    gc.databind.registry.getBinding('props.calculation_value_IPDAngle');
    gc.databind.registry.getBinding('props.calculation_value_ISDSpeed');
    gc.databind.registry.getBinding('props.calculation_value_SpeedRefOpenLoop');
    gc.databind.registry.getBinding('props.calculation_value_IqRefOpenLoop');
    gc.databind.registry.getBinding('props.calculation_value_IqRefRotorAlign');
    gc.databind.registry.getBinding('props.calculation_value_Ed');
    gc.databind.registry.getBinding('props.calculation_value_Eq');
    gc.databind.registry.getBinding('props.calculation_value_EstimatedRotorAngle');
    gc.databind.registry.getBinding('props.calculation_value_SpeedFeedback');
    
    // gc.databind.registry.getBinding('props.calculation_value_MotorPhaseResistanceInput');
    // gc.databind.registry.getBinding('props.calculation_value_MotorPhaseInductanceInput');
    // gc.databind.registry.getBinding('props.calculation_value_MotorPhaseBEMFConstantInput');
    // gc.databind.registry.getBinding('props.calculation_value_MPETMotorResistance');
    // gc.databind.registry.getBinding('props.calculation_value_MPETMotorInductance');
    // gc.databind.registry.getBinding('props.calculation_value_MPETMotorBEMFConstant');
    // gc.databind.registry.getBinding('props.calculation_value_MotorResistanceStatus');
    // gc.databind.registry.getBinding('props.calculation_value_MotorInductanceStatus');
    // gc.databind.registry.getBinding('props.calculation_value_MotorBEMFStatus');
    
    gc.databind.registry.getBinding('props.calculation_value_DutyOn1');
    gc.databind.registry.getBinding('props.calculation_value_DutyOff1');
    gc.databind.registry.getBinding('props.calculation_value_DutyClamp1');
    gc.databind.registry.getBinding('props.calculation_value_DutyA');
    gc.databind.registry.getBinding('props.calculation_value_DutyB');
    gc.databind.registry.getBinding('props.calculation_value_DutyC');
    gc.databind.registry.getBinding('props.calculation_value_DutyD');
    gc.databind.registry.getBinding('props.calculation_value_DutyE');
    gc.databind.registry.getBinding('props.calculation_value_DutyOn2');
    gc.databind.registry.getBinding('props.calculation_value_DutyOff2');
    gc.databind.registry.getBinding('props.calculation_value_DutyClamp2');
    gc.databind.registry.getBinding('props.calculation_value_SpeedOff1');
    gc.databind.registry.getBinding('props.calculation_value_SpeedClamp1');
    gc.databind.registry.getBinding('props.calculation_value_SpeedA');
    gc.databind.registry.getBinding('props.calculation_value_SpeedB');
    gc.databind.registry.getBinding('props.calculation_value_SpeedC');
    gc.databind.registry.getBinding('props.calculation_value_SpeedD');
    gc.databind.registry.getBinding('props.calculation_value_SpeedE');
    gc.databind.registry.getBinding('props.calculation_value_SpeedOff2');
    gc.databind.registry.getBinding('props.calculation_value_SpeedClamp2');
    
    // To be Clarified
    gc.databind.registry.getBinding('props.calculation_value_MaximumSpeed');
    gc.databind.registry.getBinding('props.calculation_value_AbnormalSpeedThreshold');
    gc.databind.registry.getBinding('props.calculation_value_Polepairs');
    gc.databind.registry.getBinding('props.calculation_value_Polepairs').setValue(0);
    gc.databind.registry.getBinding('props.calculation_value_MechanicalSpeed');
    gc.databind.registry.getBinding('props.calculation_value_MechanicalSpeed').setValue(0);

    gc.databind.registry.getBinding('props.calculation_value_IlimitValue').setValue(2);
    gc.databind.registry.getBinding('props.calculation_value_MaxCurrent');
    gc.databind.registry.getBinding('props.calculation_value_MaxCurrent').setValue(2);
    
    gc.databind.registry.getBinding('props.calculation_value_Phase2PhaseResistance');
    gc.databind.registry.getBinding('props.calculation_value_Phase2PhaseResistance').setValue(0);
    gc.databind.registry.getBinding('props.calculation_value_PhaseResistance');

    gc.databind.registry.getBinding('props.calculation_value_BemfResult');
    gc.databind.registry.getBinding('props.calculation_value_BemfPolepairs');
    gc.databind.registry.getBinding('props.calculation_value_BemfPolepairs').setValue(1);
    gc.databind.registry.getBinding('props.calculation_value_BemfInput');
    gc.databind.registry.getBinding('props.calculation_value_BemfInput').setValue(0);

    gc.databind.registry.getBinding('props.calculation_value_BemfResult2');
    gc.databind.registry.getBinding('props.calculation_value_Bemf2Polepairs');
    gc.databind.registry.getBinding('props.calculation_value_Bemf2Polepairs').setValue(1);
    gc.databind.registry.getBinding('props.calculation_value_TorqueConstant');
    gc.databind.registry.getBinding('props.calculation_value_TorqueConstant').setValue(0);

    gc.databind.registry.getBinding('props.calculation_value_BemfResult3');
    gc.databind.registry.getBinding('props.calculation_value_PeakVoltage');
    gc.databind.registry.getBinding('props.calculation_value_PeakVoltage').setValue(0);
    gc.databind.registry.getBinding('props.calculation_value_TimePeriod');
    gc.databind.registry.getBinding('props.calculation_value_TimePeriod').setValue(0);

    gc.databind.registry.getBinding('props.calculation_value_SpeedLoopKp');
    gc.databind.registry.getBinding('props.calculation_value_IqReference');
    gc.databind.registry.getBinding('props.calculation_value_IqReference').setValue(0);
    gc.databind.registry.getBinding('props.calculation_value_MaxElectricSpeed');
    gc.databind.registry.getBinding('props.calculation_value_MaxElectricSpeed').setValue(1);

    gc.databind.registry.getBinding('props.calculation_value_SpeedLoopKi');
    gc.databind.registry.getBinding('props.calculation_value_SpeedLoopKp1');
    gc.databind.registry.getBinding('props.calculation_value_SpeedLoopKp1').setValue(0);
    
    gc.databind.registry.getBinding('props.scaled_value_SpeedLoopKp').setValue(0);
    gc.databind.registry.getBinding('props.scaled_value_SpeedLoopKi').setValue(0);
    gc.databind.registry.getBinding('props.scaled_value_SpeedLoopMaxElectricalSpeed').setValue(0);
    gc.databind.registry.getBinding('props.scaled_value_LeadAngle').setValue(0);
    
    gc.databind.registry.getBinding('props.calculation_value_IpdCurrentThreshold_A').setValue(2);
    gc.databind.registry.getBinding('props.calculation_value_IpdCurrentThreshold_V');
    gc.databind.registry.getBinding('props.calculation_value_IpdCurrentThreshold_V').setValue(2);
    
    gc.databind.registry.getBinding('props.calculation_value_AlignCurrentThreshold_A').setValue(2);
    gc.databind.registry.getBinding('props.calculation_value_AlignCurrentThreshold_V');
    gc.databind.registry.getBinding('props.calculation_value_AlignCurrentThreshold_V').setValue(2);
    
    gc.databind.registry.getBinding('props.calculation_value_FastDecelCurrentThreshold_A').setValue(2);
    gc.databind.registry.getBinding('props.calculation_value_FastDecelCurrentThreshold_V');
    gc.databind.registry.getBinding('props.calculation_value_FastDecelCurrentThreshold_V').setValue(2);

    // To be Clarified
    ////////////////////////////////////////////////////////////////
    // Maximum Speed Formula Calculation
    gc.databind.registry.bind('props.calculation_value_MaximumSpeed',
    {
        pole_pairs: 'props.calculation_value_Polepairs',
        mechanical_speed: 'props.calculation_value_MechanicalSpeed'
    },
    function (value)
    {
        return ((value.pole_pairs * value.mechanical_speed) / 60).toFixed();
    }
    );
    
    // Abnormal Speed Threshold Calculation
    gc.databind.registry.bind('props.calculation_value_AbnormalSpeedThreshold',
    {
        max_speed: 'props.value_MaxSpeed'
    },
    function (value)
    {
        return (value.max_speed * 1.5).toFixed();
    }
    );
    
    // ILIMIT Value Formula Calculation
    gc.databind.registry.bind('props.calculation_value_IlimitValue',
    {
        max_current: 'props.calculation_value_MaxCurrent', //two decimal places
        csa_gain: 'my_model.GD_CONFIG1.CSA_GAIN', //two decimal places
        ilimit: 'my_model.FAULT_CONFIG1.ILIMIT'
    },
    function (value)
    {
        return (value.max_current * (0.15 * math.pow(2,value.csa_gain))).toFixed(2);
    }
    );

    // Phase Resistanc Formula Calculation
    gc.databind.registry.bind('props.calculation_value_PhaseResistance',
    'props.calculation_value_Phase2PhaseResistance',
    function (value)
    {
        return (value / 2).toFixed(3);
    }
    );

    // BEMF Constant Formula Calculation
    gc.databind.registry.bind('props.calculation_value_BemfResult',
    {
        pole_pairs: 'props.calculation_value_BemfPolepairs',
        bemf_constant: 'props.calculation_value_BemfInput'
    },
    function (value)
    {
        return (value.bemf_constant * (60 / value.pole_pairs)).toFixed(3);
    }
    );

    
    // BEMF Constant Formula no(4) Calculation
    gc.databind.registry.bind('props.calculation_value_BemfResult2',
    {
        pole_pairs: 'props.calculation_value_Bemf2Polepairs',
        torque_constant: 'props.calculation_value_TorqueConstant'
    },
    function (value)
    {
        return (value.torque_constant * (6.28 / value.pole_pairs)).toFixed(3);
    }
    );

    // BEMF Constant Formula no(5) Calculation
    gc.databind.registry.bind('props.calculation_value_BemfResult3',
    {
        peak_voltage: 'props.calculation_value_PeakVoltage',
        time_period: 'props.calculation_value_TimePeriod'
    },
    function (value)
    {
        return ((value.peak_voltage * value.time_period) / 1.732).toFixed(3);
    }
    );

    // Speed Loop Kp calculation
    gc.databind.registry.bind('props.calculation_value_SpeedLoopKp',
    {
        iq_reference: 'props.calculation_value_IqReference',
        max_elec_speed: 'props.calculation_value_MaxElectricSpeed'
    },
    function (value)
    {
        return (value.iq_reference / value.max_elec_speed).toFixed();
    }
    );

    // Speed Loop Ki calculation
    gc.databind.registry.bind('props.calculation_value_SpeedLoopKi',
    {
        speed_loop_kp: 'props.calculation_value_SpeedLoopKp1'
    },
    function (value)
    {
        return (0.1 * value.speed_loop_kp).toFixed();
    }
    );
    
    // IPD Current Threshold Calculation
    gc.databind.registry.bind('props.calculation_value_IpdCurrentThreshold_V',
    {
        ipd_current_thr: 'props.calculation_value_IpdCurrentThreshold_A', //two decimal places
        csa_gain: 'my_model.GD_CONFIG1.CSA_GAIN', //two decimal places

    },
    function (value)
    {
        return (value.ipd_current_thr * (0.15 * math.pow(2,value.csa_gain))).toFixed(2);
    }
    );
    
    // Align Current Threshold Calculation
    gc.databind.registry.bind('props.calculation_value_AlignCurrentThreshold_V',
    {
        align_current_thr: 'props.calculation_value_AlignCurrentThreshold_A', //two decimal places
        csa_gain: 'my_model.GD_CONFIG1.CSA_GAIN', //two decimal places

    },
    function (value)
    {
        return (value.align_current_thr * (0.15 * math.pow(2,value.csa_gain))).toFixed(2);
    }
    );
    
    // Fast Deceleration Current Threshold Calculation
    gc.databind.registry.bind('props.calculation_value_FastDecelCurrentThreshold_V',
    {
        fast_decel_current_thr: 'props.calculation_value_FastDecelCurrentThreshold_A', //two decimal places
        csa_gain: 'my_model.GD_CONFIG1.CSA_GAIN', //two decimal places

    },
    function (value)
    {
        return (value.fast_decel_current_thr * (0.15 * math.pow(2,value.csa_gain))).toFixed(2);
    }
    );

    ////////////////////////////////////////////////////////////////////////

    
    // CALCULATIONS
    //////////////////////////////////////////////////////////////////////
    // Bus Current Limit
    // gc.databind.registry.bind('props.calculation_value_BusCurrentLimit',
    // {
    //     bus_current_limit_index: 'my_model.PERI_CONFIG1.BUS_CURRENT_LIMIT',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var bus_current_limit = getDisplayValue("PERI_CONFIG1", "BUS_CURRENT_LIMIT", value.bus_current_limit_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (bus_current_limit / 100)).toFixed(3);
    // }
    // );
    
    // IPD Current Threshold
    // gc.databind.registry.bind('props.calculation_value_IPDCurrentThreshold',
    // {
    //     ipd_current_thr_index: 'my_model.MOTOR_STARTUP1.IPD_CURR_THR',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var ipd_current_thr = getDisplayValue("MOTOR_STARTUP1", "IPD_CURR_THR", value.ipd_current_thr_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (ipd_current_thr / 100)).toFixed(3);
    // }
    // );
    
    // MPET IPD Current Threshold
    // gc.databind.registry.bind('props.calculation_value_MPETIPDCurrentThreshold',
    // {
    //     mpet_ipd_current_limit_index: 'my_model.INT_ALGO_1.MPET_IPD_CURRENT_LIMIT',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var mpet_ipd_current_limit = getDisplayValue("INT_ALGO_1", "MPET_IPD_CURRENT_LIMIT", value.mpet_ipd_current_limit_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (mpet_ipd_current_limit / 100)).toFixed(3);
    // }
    // );
    
    // MPET Open Loop Current Reference
    // gc.databind.registry.bind('props.calculation_value_MPETOpenLoopCurrentReference',
    // {
    //     mpet_open_loop_current_ref_index: 'my_model.INT_ALGO_1.MPET_OPEN_LOOP_CURRENT_REF',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var mpet_open_loop_current_ref = getDisplayValue("INT_ALGO_1", "MPET_OPEN_LOOP_CURRENT_REF", value.mpet_open_loop_current_ref_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (mpet_open_loop_current_ref / 100)).toFixed(3);
    // }
    // );
    
    // // MPET Open Loop Speed Reference
    // gc.databind.registry.bind('props.calculation_value_MPETOpenLoopSpeedReference',
    // {
    //     mpet_open_loop_speed_ref_index: 'my_model.INT_ALGO_1.MPET_OPEN_LOOP_SPEED_REF',
    //     max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    // },
    // function (value)
    // {
    //     var mpet_open_loop_speed_ref = getDisplayValue("INT_ALGO_1", "MPET_OPEN_LOOP_SPEED_REF", value.mpet_open_loop_speed_ref_index);
    //     return (value.max_speed / 6 * (mpet_open_loop_speed_ref / 100)).toFixed(3);
    // }
    // );
    
    // // Minimum Speed Threshold to Recynchronize to Close Loop
    // gc.databind.registry.bind('props.calculation_value_MinimumSpeedThresholdtoResync',
    // {
    //     fw_drv_resyn_thr_index: 'my_model.ISD_CONFIG.FW_DRV_RESYN_THR',
    //     max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    // },
    // function (value)
    // {
    //     var fw_drv_resyn_thr = getDisplayValue("ISD_CONFIG", "FW_DRV_RESYN_THR", value.fw_drv_resyn_thr_index);
    //     return (value.max_speed / 6 * (fw_drv_resyn_thr / 100)).toFixed(3);
    // }
    // );
    
    // Brake Current Threshold
    // gc.databind.registry.bind('props.calculation_value_BrakeCurrentThreshold',
    // {
    //     brk_curr_thr_index: 'my_model.ISD_CONFIG.BRK_CURR_THR',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var brk_curr_thr = getDisplayValue("ISD_CONFIG", "BRK_CURR_THR", value.brk_curr_thr_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (brk_curr_thr / 100)).toFixed(3);
    // }
    // );
    
    // Align or Slow First Cycle Current Limit
    // gc.databind.registry.bind('props.calculation_value_AlignOrSlowFirstCycleCurrentLimit',
    // {
    //     align_or_slow_current_limit_index: 'my_model.MOTOR_STARTUP1.ALIGN_OR_SLOW_CURRENT_ILIMIT',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var align_or_slow_current_limit = getDisplayValue("MOTOR_STARTUP1", "ALIGN_OR_SLOW_CURRENT_ILIMIT", value.align_or_slow_current_limit_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (align_or_slow_current_limit / 100)).toFixed(3);
    // }
    // );
    
    // // Frequency of First Cycle
    // gc.databind.registry.bind('props.calculation_value_FrequencyFirstCycle',
    // {
    //     slow_first_cyc_freq_index: 'my_model.MOTOR_STARTUP2.SLOW_FIRST_CYC_FREQ',
    //     max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    // },
    // function (value)
    // {
    //     var slow_first_cyc_freq = getDisplayValue("MOTOR_STARTUP2", "SLOW_FIRST_CYC_FREQ", value.slow_first_cyc_freq_index);
    //     return (value.max_speed / 6 * (slow_first_cyc_freq / 100)).toFixed(3);
    // }
    // );
    
    // Open Loop Current Limit During Speed Reversal
    // gc.databind.registry.bind('props.calculation_value_OpenLoopCurrentLimitSpeedReversal',
    // {
    //     rev_drv_open_loop_current_index: 'my_model.ISD_CONFIG.REV_DRV_OPEN_LOOP_CURRENT',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var rev_drv_open_loop_current = getDisplayValue("ISD_CONFIG", "REV_DRV_OPEN_LOOP_CURRENT", value.rev_drv_open_loop_current_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (rev_drv_open_loop_current / 100)).toFixed(3);
    // }
    // );
    
    // // Open Loop Acceleration During Open Loop Decleration in Reverse Drive A1
    // gc.databind.registry.bind('props.calculation_value_ReverseDriveOpenLoopDecelerationA1',
    // {
    //     rev_drv_open_loop_dec_index: 'my_model.INT_ALGO_1.REV_DRV_OPEN_LOOP_DEC',
    //     open_loop_accel_a1_index: 'my_model.REV_DRIVE_CONFIG.REV_DRV_OPEN_LOOP_ACCEL_A1'
    // },
    // function (value)
    // {
    //     var rev_drv_open_loop_dec = getDisplayValue("INT_ALGO_1", "REV_DRV_OPEN_LOOP_DEC", value.rev_drv_open_loop_dec_index);
    //     var open_loop_accel_a1 = getDisplayValue("REV_DRIVE_CONFIG","REV_DRV_OPEN_LOOP_ACCEL_A1",value.open_loop_accel_a1_index);
    //     return (open_loop_accel_a1 * (rev_drv_open_loop_dec / 100)).toFixed(3);
    // }
    // );
    
    // // Open Loop Acceleration During Open Loop Decleration in Reverse Drive A2
    // gc.databind.registry.bind('props.calculation_value_ReverseDriveOpenLoopDecelerationA2',
    // {
    //     rev_drv_open_loop_dec_index: 'my_model.INT_ALGO_1.REV_DRV_OPEN_LOOP_DEC',
    //     open_loop_accel_a2_index: 'my_model.REV_DRIVE_CONFIG.REV_DRV_OPEN_LOOP_ACCEL_A2'
    // },
    // function (value)
    // {
    //     var rev_drv_open_loop_dec = getDisplayValue("INT_ALGO_1", "REV_DRV_OPEN_LOOP_DEC", value.rev_drv_open_loop_dec_index);
    //     var open_loop_accel_a2 = getDisplayValue("REV_DRIVE_CONFIG","REV_DRV_OPEN_LOOP_ACCEL_A2",value.open_loop_accel_a2_index);
    //     return (open_loop_accel_a2 / 10 * (rev_drv_open_loop_dec / 100)).toFixed(3);
    // }
    // );
    
    // // Reverse Deceleration Speed Threshold to Transition to Open Loop
    // gc.databind.registry.bind('props.calculation_value_ReverseDeclerationSpeedThreshold',
    // {
    //     rev_drv_handoff_thr_index: 'my_model.ISD_CONFIG.REV_DRV_HANDOFF_THR',
    //     max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    // },
    // function (value)
    // {
    //     var rev_drv_handoff_thr = getDisplayValue("ISD_CONFIG", "REV_DRV_HANDOFF_THR", value.rev_drv_handoff_thr_index);
    //     return (value.max_speed / 6 * (rev_drv_handoff_thr / 100)).toFixed(3);
    // }
    // );
    
    // Bus Current Limit During Plug In Operation
    // gc.databind.registry.bind('props.calculation_value_PlugBusCurrentLimit',
    // {
    //     plug_bus_current_limit_index: 'my_model.REV_DRIVE_CONFIG.ACTIVE_BRAKE_CURRENT_LIMIT',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var plug_bus_current_limit = getDisplayValue("REV_DRIVE_CONFIG", "ACTIVE_BRAKE_CURRENT_LIMIT", value.plug_bus_current_limit_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (plug_bus_current_limit / 100)).toFixed(3);
    // }
    // );
    
    // Open Loop Current Limit
    // gc.databind.registry.bind('props.calculation_value_OpenLoopCurrentLimit',
    // {
    //     ol_limit_index: 'my_model.MOTOR_STARTUP2.OL_ILIMIT',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var ol_limit = getDisplayValue("MOTOR_STARTUP2", "OL_ILIMIT", value.ol_limit_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (ol_limit / 100)).toFixed(3);
    // }
    // );
    
    // // Open to Closed Loop Threshold
    // gc.databind.registry.bind('props.calculation_value_OpenToClosedLoopCurrentLimit',
    // {
    //     opn_cl_handoff_thr_index: 'my_model.MOTOR_STARTUP2.OPN_CL_HANDOFF_THR',
    //     max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    // },
    // function (value)
    // {
    //     var opn_cl_handoff_thr = getDisplayValue("MOTOR_STARTUP2", "OPN_CL_HANDOFF_THR", value.opn_cl_handoff_thr_index);
    //     return (value.max_speed / 6 * (opn_cl_handoff_thr / 100)).toFixed(3);
    // }
    // );
    
    // Current Limit for Torque PI Loop
    // gc.databind.registry.bind('props.calculation_value_TorquePILoopCurrentLimit',
    // {
    //     torque_pi_ilimit_index: 'my_model.FAULT_CONFIG1.ILIMIT',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var torque_pi_ilimit = getDisplayValue("FAULT_CONFIG1", "ILIMIT", value.torque_pi_ilimit_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (torque_pi_ilimit / 100)).toFixed(3);
    // }
    // );
    
    // Active Spin Down Speed Threshold
    gc.databind.registry.bind('props.calculation_value_ActiveSpinDownSpeedThreshold',
    {
        act_spin_thr_index: 'my_model.CLOSED_LOOP2.ACT_SPIN_BRK_THR',
        max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    },
    function (value)
    {
        var act_spin_thr = getDisplayValue("CLOSED_LOOP2", "ACT_SPIN_BRK_THR", value.act_spin_thr_index);
        return (value.max_speed / 6 * (act_spin_thr / 100)).toFixed(3);
    }
    );
    
    // Speed Threshold for BRAKE Pin and Motor Stop Options
    gc.databind.registry.bind('props.calculation_value_MotorStopSpeedThreshold',
    {
        brake_duty_threshold_index: 'my_model.CLOSED_LOOP2.BRAKE_DUTY_THRESHOLD',
        max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    },
    function (value)
    {
        var brake_duty_threshold = getDisplayValue("CLOSED_LOOP2", "BRAKE_DUTY_THRESHOLD", value.brake_duty_threshold_index);
        return (value.max_speed / 6 * (brake_duty_threshold / 100)).toFixed(3);
    }
    );
    
    // Hardware Lock Detection Current Limit
    // gc.databind.registry.bind('props.calculation_value_HWLockDetectionCurrentLimit',
    // {
    //     hw_lock_ilimit_index: 'my_model.FAULT_CONFIG1.HW_LOCK_ILIMIT',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var hw_lock_ilimit = getDisplayValue("FAULT_CONFIG1", "HW_LOCK_ILIMIT", value.hw_lock_ilimit_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (hw_lock_ilimit / 100)).toFixed(3);
    // }
    // );
    
    // Lock Detection Current Threshold
    // gc.databind.registry.bind('props.calculation_value_LockDetectionCurrentThreshold',
    // {
    //     lock_ilimit_index: 'my_model.FAULT_CONFIG1.LOCK_ILIMIT',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var lock_ilimit = getDisplayValue("FAULT_CONFIG1", "LOCK_ILIMIT", value.lock_ilimit_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (lock_ilimit / 100)).toFixed(3);
    // }
    // );
    
    // // Abnormal Speed Lock Threshold
    // gc.databind.registry.bind('props.calculation_value_AbnormalSpeedLockThreshold',
    // {
    //     lock_abn_speed_index: 'my_model.FAULT_CONFIG2.LOCK_ABN_SPEED',
    //     max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    // },
    // function (value)
    // {
    //     var lock_abn_speed = getDisplayValue("FAULT_CONFIG2", "LOCK_ABN_SPEED", value.lock_abn_speed_index);
    //     return (value.max_speed / 6 * (lock_abn_speed / 100)).toFixed(3);
    // }
    // );
    
    // // Abnormal BEMF Lock Threshold
    // gc.databind.registry.bind('props.calculation_value_AbnormalBEMFLockThreshold',
    // {
    //     abnormal_bemf_thr_index: 'my_model.FAULT_CONFIG2.ABNORMAL_BEMF_THR',
    // },
    // function (value)
    // {
    //     var abnormal_bemf_thr = getDisplayValue("FAULT_CONFIG2", "ABNORMAL_BEMF_THR", value.abnormal_bemf_thr_index);
    //     return ("TODO");
    // }
    // );
    
    // No Motor Lock Threshold
    // gc.databind.registry.bind('props.calculation_value_NoMotorLockThreshold',
    // {
    //     no_mtr_thr_index: 'my_model.FAULT_CONFIG2.NO_MTR_THR',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var no_mtr_thr = getDisplayValue("FAULT_CONFIG2", "NO_MTR_THR", value.no_mtr_thr_index);
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (base_current * (no_mtr_thr / 100)).toFixed(3);
    // }
    // );
    
    // Maximum Speed
    gc.databind.registry.bind('props.value_MaxSpeed',
    {
        max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    },
    function (value) // getting from register (getter)
    {
        return (value.max_speed / 20);
    },
    function (value) // setting register (setter)
    {
        return {max_speed: ((value * 20).toFixed())};
    }
    );
    
    // Speed Command
    gc.databind.registry.bind('props.calculation_value_SpeedCommand',
    {
        speed_cmd: 'my_model.ALGO_STATUS1.SPEED_CMD'
    },
    function (value)
    {
        return (value.speed_cmd / 4095 * 100).toFixed(2);
    }
    );
    
    // Voltage Magnitude
    gc.databind.registry.bind('props.calculation_value_VoltageMagnitude',
    {
        volt_mag: 'my_model.ALGO_STATUS1.VOLT_MAG'
    },
    function (value)
    {
        return (100 * (value.volt_mag / Math.pow(2,15))).toFixed(2);
    }
    );
    
    // Motor Electrical Speed (Hz)
    gc.databind.registry.bind('props.calculation_value_MotorElectricalSpeed', 
    {
        motor_spd: 'my_model.SYS_STATUS2.SPEED_STATUS'
    },
    function (value) 
    {
        return (value.motor_spd / 10).toFixed(2);
    }
    );
    
    // // VM Voltage
    // gc.databind.registry.bind('props.calculation_value_VMVoltage',
    // {
    //     vm_voltage: 'my_model.VM_VOLTAGE.VM_VOLTAGE'
    //     // bus_voltage: 'my_model.DEVICE_CONFIG1.BUS_VOLT'
    // },
    // function (value)
    // {
    //     // var bus_volt_enum = [15, 30, 60, 60];
    //     return (value.vm_voltage * 60.0 / Math.pow(2,27)).toFixed(2);
    // }
    // );
    
    // // Voltage Gain Feedback
    // gc.databind.registry.bind('props.calculation_value_VoltageGain',
    // {
    //     voltage_gain_feedback: 'my_model.VOLTAGE_GAIN_FEEDBACK.VOLTAGE_GAIN_FEEDBACK'
    // },
    // function (value)
    // {
    //     return (value.voltage_gain_feedback);
    // }
    // );
    
    // // CSA Gain Feedback
    // gc.databind.registry.bind('props.calculation_value_CSAGain',
    // {
    //     csa_gain_feedback: 'my_model.CSA_GAIN_FEEDBACK.CSA_GAIN_FEEDBACK'
    // },
    // function (value)
    // {
    //     return (value.csa_gain_feedback);
    // }
    // );
    
    // // Id Ref Close Loop
    // gc.databind.registry.bind('props.calculation_value_IdRefClosedLoop',
    // {
    //     id_ref_close_loop: 'my_model.ID_REF_CLOSED_LOOP.ID_REF_CLOSED_LOOP'
    // },
    // function (value)
    // {
    //     return ((value.id_ref_close_loop|0) / (Math.pow(2,27))).toFixed(2);
    // }
    // );

    // // Iq Ref Close Loop
    // gc.databind.registry.bind('props.calculation_value_IqRefClosedLoop',
    // {
    //     iq_ref_close_loop: 'my_model.IQ_REF_CLOSED_LOOP.IQ_REF_CLOSED_LOOP'
    // },
    // function (value)
    // {
    //     return ((value.iq_ref_close_loop|0) / (Math.pow(2,27))).toFixed(2);
    // }
    // );
    
    // // Estimated Id
    // gc.databind.registry.bind('props.calculation_value_EstimatedId',
    // {
    //     id: 'my_model.ID.ID'
    // },
    // function (value)
    // {
    //     return ((value.id|0) / (Math.pow(2,27))).toFixed(2);
    // }
    // );

    // // Estimated Iq
    // gc.databind.registry.bind('props.calculation_value_EstimatedIq',
    // {
    //     iq: 'my_model.IQ.IQ'
    // },
    // function (value)
    // {
    //     return ((value.iq|0) / (Math.pow(2,27))).toFixed(2);
    // }
    // );

    // // Vd
    // gc.databind.registry.bind('props.calculation_value_Vd',
    // {
    //     vd: 'my_model.VD.VD'
    // },
    // function (value)
    // {
    //     return ((value.vd|0) * 60.0 / (Math.pow(2,27) * Math.sqrt(3))).toFixed(2);
    // }
    // );

    // // Vq
    // gc.databind.registry.bind('props.calculation_value_Vq',
    // {
    //     vq: 'my_model.VQ.VQ'
    // },
    // function (value)
    // {
    //     return ((value.vq|0) * 60.0 / (Math.pow(2,27) * Math.sqrt(3))).toFixed(2);
    // }
    // );

    // Bus Current
    // gc.databind.registry.bind('props.calculation_value_BusCurrent',
    // {
    //     bus_current: 'my_model.BUS_CURRENT.BUS_CURRENT',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (value.bus_current * base_current / (Math.pow(2,27) * 8)).toFixed(2);
    // }
    // );
    
    // // IPD Angle
    // gc.databind.registry.bind('props.calculation_value_IPDAngle',
    // {
    //     ipd_angle: 'my_model.IPD_ANGLE.IPD_ANGLE'
    // },
    // function (value)
    // {
    //     return (((value.ipd_angle|0) * 360 / Math.pow(2,27)) % 360).toFixed(2);
    // }
    // );

    // // ISD Speed
    // gc.databind.registry.bind('props.calculation_value_ISDSpeed',
    // {
    //     isd_speed: 'my_model.ISD_SPEED.ISD_SPEED',
    //     max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    // },
    // function (value)
    // {
    //     return ((value.isd_speed|0) * (value.max_speed/6) / Math.pow(2,27)).toFixed(2);
    // }
    // );

    // // Speed Reference Open Loop
    // gc.databind.registry.bind('props.calculation_value_SpeedRefOpenLoop',
    // {
    //     speed_ref_open_loop: 'my_model.SPEED_REF_OPEN_LOOP.SPEED_REF_OPEN_LOOP',
    //     max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    // },
    // function (value)
    // {
    //     return (value.speed_ref_open_loop * (value.max_speed/6) / Math.pow(2,27)).toFixed(2);
    // }
    // );

    // Iq Ref Open Loop
    // gc.databind.registry.bind('props.calculation_value_IqRefOpenLoop',
    // {
    //     iq_ref_open_loop: 'my_model.IQ_REF_CLOSE_LOOP.IQ_REF_OPEN_LOOP',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (value.iq_ref_open_loop * base_current / (Math.pow(2,27) * 8)).toFixed(2);
    // }
    // );

    // Iq Ref Rotor Align
    // gc.databind.registry.bind('props.calculation_value_IqRefRotorAlign',
    // {
    //     iq_ref_rotor_align: 'my_model.IQ_REF_CLOSE_LOOP.IQ_REF_ROTOR_ALIGN',
    //     base_current: 'my_model.DEVICE_CONFIG1.BASE_CURRENT'
    // },
    // function (value)
    // {
    //     var base_current = value.base_current * 1200.0 / 32768.0;
    //     return (value.iq_ref_rotor_align * base_current / (Math.pow(2,27) * 8)).toFixed(2);
    // }
    // );

    // // ED
    // gc.databind.registry.bind('props.calculation_value_Ed',
    // {
    //     ed: 'my_model.ED.ED',
    // },
    // function (value)
    // {
    //     return ((value.ed|0) * 60.0 / (Math.pow(2,27) * Math.sqrt(3))).toFixed(2);
    // }
    // );

    // // EQ
    // gc.databind.registry.bind('props.calculation_value_Eq',
    // {
    //     eq: 'my_model.EQ.EQ',
    // },
    // function (value)
    // {
    //     return ((value.eq|0) * 60.0 / (Math.pow(2,27) * Math.sqrt(3))).toFixed(2);
    // }
    // );

    // // Rotor Angle
    // gc.databind.registry.bind('props.calculation_value_EstimatedRotorAngle',
    // {
    //     theta_est: 'my_model.THETA_EST.THETA_EST'
    // },
    // function (value)
    // {
    //     return (((value.theta_est|0) * 360 / Math.pow(2,27)) % 360).toFixed(2);
    // }
    // );

    // // Speed Feedback
    // gc.databind.registry.bind('props.calculation_value_SpeedFeedback',
    // {
    //     speed_fdbk: 'my_model.SPEED_FDBK.SPEED_FDBK',
    //     max_speed: 'my_model.CLOSED_LOOP3.MAX_SPEED'
    // },
    // function (value)
    // {
    //     return ((value.speed_fdbk|0) * (value.max_speed/6) / Math.pow(2,27)).toFixed(2);
    // }
    // );
    
    var motor_r_l_ke_lookup = [0.000,
                        0.006, 0.007, 0.008, 0.009, 0.010, 0.011, 0.012, 0.013,
                        0.014, 0.015, 0.016, 0.017, 0.018, 0.019, 0.020, 0.022,
                        0.024, 0.026, 0.028, 0.030, 0.032, 0.034, 0.036, 0.038,
                        0.040, 0.042, 0.044, 0.046, 0.048, 0.050, 0.052, 0.054,
                        0.056, 0.058, 0.060, 0.062, 0.064, 0.066, 0.068, 0.070,
                        0.072, 0.074, 0.076, 0.078, 0.080, 0.082, 0.084, 0.086,
                        0.088, 0.090, 0.092, 0.094, 0.096, 0.098, 0.100, 0.105,
                        0.110, 0.115, 0.120, 0.125, 0.130, 0.135, 0.140, 0.145,
                        0.150, 0.155, 0.160, 0.165, 0.170, 0.175, 0.180, 0.185,
                        0.190, 0.195, 0.200, 0.205, 0.210, 0.215, 0.220, 0.225,
                        0.230, 0.235, 0.240, 0.245, 0.250, 0.255, 0.260, 0.265,
                        0.270, 0.275, 0.280, 0.285, 0.290, 0.295, 0.300, 0.305,
                        0.310, 0.315, 0.320, 0.325, 0.330, 0.335, 0.340, 0.345,
                        0.350, 0.355, 0.360, 0.365, 0.370, 0.375, 0.380, 0.385,
                        0.390, 0.395, 0.400, 0.405, 0.410, 0.415, 0.420, 0.425,
                        0.430, 0.435, 0.440, 0.445, 0.450, 0.455, 0.460, 0.465,
                        0.470, 0.475, 0.480, 0.485, 0.490, 0.495, 0.500, 0.510,
                        0.520, 0.530, 0.540, 0.550, 0.560, 0.570, 0.580, 0.590,
                        0.600, 0.610, 0.620, 0.630, 0.640, 0.650, 0.660, 0.670,
                        0.680, 0.690, 0.700, 0.720, 0.740, 0.760, 0.780, 0.800,
                        0.820, 0.840, 0.860, 0.880, 0.900, 0.920, 0.940, 0.960,
                        0.980, 1.000, 1.050, 1.100, 1.150, 1.200, 1.250, 1.300,
                        1.350, 1.400, 1.450, 1.500, 1.550, 1.600, 1.650, 1.700,
                        1.750, 1.800, 1.850, 1.900, 1.950, 2.000, 2.050, 2.100,
                        2.200, 2.300, 2.400, 2.500, 2.600, 2.700, 2.800, 2.900,
                        3.000, 3.200, 3.400, 3.600, 3.800, 4.000, 4.200, 4.400,
                        4.600, 4.800, 5.000, 5.200, 5.400, 5.600, 5.800, 6.000,
                        6.200, 6.400, 6.600, 6.800, 7.000, 7.200, 7.400, 7.600,
                        7.800, 8.000, 8.200, 8.400, 8.600, 8.800, 9.000, 9.200,
                        9.400, 9.600, 9.800, 10.00, 10.50, 11.00, 11.50, 12.00,
                        12.50, 13.00, 13.50, 14.00, 14.50, 15.00, 15.50, 16.00,
                        16.50, 17.00, 17.50, 18.00, 18.50, 19.00, 20.00];

    // // Motor Phase Resistance input
    // gc.databind.registry.bind('props.calculation_value_MotorPhaseResistanceInput',
    //     "my_model.CLOSED_LOOP2.MOTOR_RES",
    // function (value)
    // {
    //     return motor_r_l_ke_lookup[value];
    // }
    // );

    // // Motor Phase Inductance input
    // gc.databind.registry.bind('props.calculation_value_MotorPhaseInductanceInput',
    //     "my_model.CLOSED_LOOP2.MOTOR_IND",
    // function (value)
    // {
    //     return motor_r_l_ke_lookup[value];
    // }
    // );

    // // Motor Phase BEMF constant input
    // gc.databind.registry.bind('props.calculation_value_MotorPhaseBEMFConstantInput',
    //     "my_model.CLOSED_LOOP3.MOTOR_BEMF_CONST",
    // function (value)
    // {
    //     return motor_r_l_ke_lookup[value] * 100;
    // }
    // );
  
    // // MPET Motor Resistance
    // gc.databind.registry.bind('props.calculation_value_MPETMotorResistance',
    //     "my_model.MTR_PARAMS.MOTOR_R",
    // function (value)
    // {
    //     return motor_r_l_ke_lookup[value].toFixed(3);
    // }
    // );
  
    // // MEPT Motor Inductance
    // gc.databind.registry.bind('props.calculation_value_MPETMotorInductance',
    //     "my_model.MTR_PARAMS.MOTOR_L",
    // function (value)
    // {
    //     return motor_r_l_ke_lookup[value].toFixed(3);
    // }
    // );
    
    // // MPET Motor BEMF constant
    // gc.databind.registry.bind('props.calculation_value_MPETMotorBEMFConstant',
    //     "my_model.MTR_PARAMS.MOTOR_BEMF_CONST",
    // function (value)
    // {
    //     return (motor_r_l_ke_lookup[value] * 100).toFixed(3);
    // }
    // );

    // // Motor Resistance Status
    // gc.databind.registry.bind('props.calculation_value_MotorResistanceStatus',
    // {
    //     motor_r: 'my_model.MTR_PARAMS.MOTOR_R'
    // },
    // function (value)
    // {
    //     return (value.motor_r === 0) ? "Self Measurement" : motor_r_l_ke_lookup[value.motor_r];
    // }
    // );

    // // Motor Inductance Status
    // gc.databind.registry.bind('props.calculation_value_MotorInductanceStatus',
    // {
    //     motor_l: 'my_model.MTR_PARAMS.MOTOR_L'
    // },
    // function (value)
    // {
    //     return (value.motor_l === 0) ? "Self Measurement" : motor_r_l_ke_lookup[value.motor_l];
    // }
    // );

    // // Motor BEMF Status
    // gc.databind.registry.bind('props.calculation_value_MotorBEMFStatus',
    // {
    //     motor_bemf_const: 'my_model.MTR_PARAMS.MOTOR_BEMF_CONST'
    // },
    // function (value)
    // {
    //     return (value.motor_bemf_const === 0) ? "Self Measurement" : motor_r_l_ke_lookup[value.motor_bemf_const];
    // }
    // );
    
    // // Turn On Duty Cycle 1
    // gc.databind.registry.bind('props.calculation_value_DutyOn1',
    // {
    //     duty_on1: 'my_model.SPEED_PROFILES1.DUTY_ON1'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.duty_on1 = (value.duty_on1 / 255 * 100);
    //     updatePlotDuty();
        
    //     return (value.duty_on1 / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {duty_on1: ((value / 100 * 255).toFixed())};
    // }
    // );
    
    // // Turn Off Duty Cycle 1
    // gc.databind.registry.bind('props.calculation_value_DutyOff1',
    // {
    //     duty_off1: 'my_model.SPEED_PROFILES1.DUTY_OFF1'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.duty_off1 = (value.duty_off1 / 255 * 100);
    //     updatePlotDuty();
        
    //     return (value.duty_off1 / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {duty_off1: ((value / 100 * 255).toFixed())};
    // }
    // );
    
    // // Duty Cycle for Clamping Speed 1
    // gc.databind.registry.bind('props.calculation_value_DutyClamp1',
    // {
    //     duty_clamp1: 'my_model.SPEED_PROFILES1.DUTY_CLAMP1'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.duty_clamp1 = (value.duty_clamp1 / 255 * 100);
    //     updatePlotDuty();
        
    //     return (value.duty_clamp1 / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {duty_clamp1: ((value / 100 * 255).toFixed())};
    // }
    // );
        
    // // Duty Cycle A
    // gc.databind.registry.bind('props.calculation_value_DutyA',
    // {
    //     duty_a_lsb: 'my_model.SPEED_PROFILES2.DUTY_A',
    //     duty_a_msb: 'my_model.SPEED_PROFILES1.DUTY_A'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.duty_a = (((value.duty_a_lsb & 0x07) | (value.duty_a_msb << 3)) / 255 * 100);
    //     updatePlotDuty();
        
    //     return (((value.duty_a_lsb & 0x07) | (value.duty_a_msb << 3)) / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {duty_a_lsb: ((value / 100 * 255).toFixed() & 0x07), duty_a_msb: (((value / 100 * 255).toFixed() & 0xF8) >> 3)}
    // }
    // );
    
    // // Duty Cycle B
    // gc.databind.registry.bind('props.calculation_value_DutyB',
    // {
    //     duty_b: 'my_model.SPEED_PROFILES2.DUTY_B'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.duty_b = (value.duty_b / 255 * 100);
    //     updatePlotDuty();
        
    //     return (value.duty_b / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {duty_b: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Duty Cycle C
    // gc.databind.registry.bind('props.calculation_value_DutyC',
    // {
    //     duty_c: 'my_model.SPEED_PROFILES2.DUTY_C'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.duty_c = (value.duty_c / 255 * 100);
    //     updatePlotDuty();
        
    //     return (value.duty_c / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {duty_c: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Duty Cycle D
    // gc.databind.registry.bind('props.calculation_value_DutyD',
    // {
    //     duty_d: 'my_model.SPEED_PROFILES2.DUTY_D'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.duty_d = (value.duty_d / 255 * 100);
    //     updatePlotDuty();
        
    //     return (value.duty_d / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {duty_d: ((value / 100 * 255).toFixed())};
    // }
    // );
    
    // // Duty Cycle E
    // gc.databind.registry.bind('props.calculation_value_DutyE',
    // {
    //     duty_e_lsb: 'my_model.SPEED_PROFILES3.DUTY_E',
    //     duty_e_msb: 'my_model.SPEED_PROFILES2.DUTY_E'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.duty_e = (((value.duty_e_lsb & 0x0F) | (value.duty_e_msb << 4)) / 255 * 100);
    //     updatePlotDuty();
        
    //     return (((value.duty_e_lsb & 0x0F) | (value.duty_e_msb << 4)) / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {duty_e_lsb: ((value / 100 * 255).toFixed() & 0x0F), duty_e_msb: (((value / 100 * 255).toFixed() & 0xF0) >> 4)};
    // }
    // );    
    
    // // Turn On Duty Cycle 2
    // gc.databind.registry.bind('props.calculation_value_DutyOn2',
    // {
    //     duty_on2: 'my_model.SPEED_PROFILES3.DUTY_ON2'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.duty_on2 = (value.duty_on2 / 255 * 100);
    //     updatePlotDuty();
        
    //     return (value.duty_on2 / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {duty_on2: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Turn Off Duty Cycle 2
    // gc.databind.registry.bind('props.calculation_value_DutyOff2',
    // {
    //     duty_off2: 'my_model.SPEED_PROFILES3.DUTY_OFF2'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.duty_off2 = (value.duty_off2 / 255 * 100);
    //     updatePlotDuty();
        
    //     return (value.duty_off2 / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {duty_off2: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Duty Cycle for Clamping Speed 2
    // gc.databind.registry.bind('props.calculation_value_DutyClamp2',
    // {
    //     duty_clamp2: 'my_model.SPEED_PROFILES3.DUTY_CLAMP2'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.duty_clamp2 = (value.duty_clamp2 / 255 * 100);
    //     updatePlotDuty();
        
    //     return (value.duty_clamp2 / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {duty_clamp2: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Turn Off Speed 1
    // gc.databind.registry.bind('props.calculation_value_SpeedOff1',
    // {
    //     speed_off1: 'my_model.SPEED_PROFILES4.SPEED_OFF1'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.speed_off1 = (value.speed_off1 / 255 * 100);
    //     updatePlotSpeed();
        
    //     return (value.speed_off1 / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {speed_off1: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Speed Clamp 1
    // gc.databind.registry.bind('props.calculation_value_SpeedClamp1',
    // {
    //     speed_clamp1: 'my_model.SPEED_PROFILES4.SPEED_CLAMP1'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.speed_clamp1 = (value.speed_clamp1 / 255 * 100);
    //     updatePlotSpeed();
        
    //     return (value.speed_clamp1 / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {speed_clamp1: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Speed A
    // gc.databind.registry.bind('props.calculation_value_SpeedA',
    // {
    //     speed_a: 'my_model.SPEED_PROFILES4.SPEED_A'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.speed_a = (value.speed_a / 255 * 100);
    //     updatePlotSpeed();
        
    //     return (value.speed_a / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {speed_a: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Speed B
    // gc.databind.registry.bind('props.calculation_value_SpeedB',
    // {
    //     speed_b_lsb: 'my_model.SPEED_PROFILES5.SPEED_B',
    //     speed_b_msb: 'my_model.SPEED_PROFILES4.SPEED_B'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.speed_b =(((value.speed_b_lsb & 0x01) | (value.speed_b_msb << 1)) / 255 * 100);
    //     updatePlotSpeed();
        
    //     return (((value.speed_b_lsb & 0x01) | (value.speed_b_msb << 1)) / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {speed_b_lsb: ((value / 100 * 255).toFixed() & 0x01), speed_b_msb: (((value / 100 * 255).toFixed() & 0xFE) >> 1)};
    // }
    // );    
    
    // // Speed C
    // gc.databind.registry.bind('props.calculation_value_SpeedC',
    // {
    //     speed_c: 'my_model.SPEED_PROFILES5.SPEED_C'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.speed_c = (value.speed_c / 255 * 100);
    //     updatePlotSpeed();
        
    //     return (value.speed_c / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {speed_c: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Speed D
    // gc.databind.registry.bind('props.calculation_value_SpeedD',
    // {
    //     speed_d: 'my_model.SPEED_PROFILES5.SPEED_D'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.speed_d = (value.speed_d / 255 * 100);
    //     updatePlotSpeed();
        
    //     return (value.speed_d / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {speed_d: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Speed E
    // gc.databind.registry.bind('props.calculation_value_SpeedE',
    // {
    //     speed_e: 'my_model.SPEED_PROFILES5.SPEED_E'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.speed_e = (value.speed_e / 255 * 100);
    //     updatePlotSpeed();
        
    //     return (value.speed_e / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {speed_e: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Turn Off Speed 2
    // gc.databind.registry.bind('props.calculation_value_SpeedOff2',
    // {
    //     speed_off2: 'my_model.SPEED_PROFILES6.SPEED_OFF2'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.speed_off2 = (value.speed_off2 / 255 * 100);
    //     updatePlotSpeed();
        
    //     return (value.speed_off2 / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {speed_off2: ((value / 100 * 255).toFixed())};
    // }
    // );    
    
    // // Speed Clamp 2
    // gc.databind.registry.bind('props.calculation_value_SpeedClamp2',
    // {
    //     speed_clamp2: 'my_model.SPEED_PROFILES6.SPEED_CLAMP2'
    // },
    // function (value) // getting from register (getter)
    // {
    //     if (speed_profile_params)
    //         speed_profile_params.speed_clamp2 = (value.speed_clamp2 / 255 * 100);
    //     updatePlotSpeed();
        
    //     return (value.speed_clamp2 / 255 * 100);
    // },
    // function (value) // setting register (setter)
    // {
    //     return {speed_clamp2: ((value / 100 * 255).toFixed())};
    // }
    // );
    
    // Speed Loop Kp Coefficient
    gc.databind.registry.bind('props.scaled_value_SpeedLoopKp',
    "my_model.CLOSED_LOOP4.SPD_LOOP_KP",
    function (value) 
    {
        return (value / 1000);
    },
    function (value)    
    {
        return (value * 1000).toFixed();
    }
    );
    
    // Speed Loop Ki Coefficient
    gc.databind.registry.bind('props.scaled_value_SpeedLoopKi',
    "my_model.CLOSED_LOOP4.SPD_LOOP_KI",
    function (value) 
    {
        return (value / 50000);
    },
    function (value) 
    {
        return (value * 50000).toFixed();
    }
    );
    
    // Speed Loop Max Electrical Speed
    gc.databind.registry.bind('props.scaled_value_SpeedLoopMaxElectricalSpeed',
    "my_model.CLOSED_LOOP3.MAX_SPEED",
    function (value)
    {
      return (value / 20);
    },
    function (value) 
    {
      return (value * 20).toFixed();
    }
    );
    
    // Lead Angle Degree
    gc.databind.registry.bind('props.scaled_value_LeadAngle',
    "my_model.CLOSED_LOOP1.LD_ANGLE",
    function (value) 
    {
        return (value * 0.12);
    },
    function (value) 
    {
        return (value / 0.12).toFixed();
    }
    );
    
}

// Helper function parses passed register, looking for the selected index, and outputs register value
function getDisplayValue(registername, bitfield, value){
    var options = templateObj.getRegField('my_model', registername, bitfield).options;
    
    for (let option of options) {
        if (option.value == value) {
            return parseFloat(option.display.replace(/[^\d.-]/g, ''));
        }
    }
}
